#!/bin/bash

date

rm -f results.output

HELAC="$1"
RUN="$2"
SUMPR="$HELAC"/Summation_Processes/
QUEUE="$3"

$FC $SUMPR/processes.f
./a.out < infile

$FC $SUMPR/prodinput1.f

for j in *all
do
	echo $j > temporaryfile1
done

./a.out < temporaryfile1

for j in cinput*
do
	k=$((k+1))
done
echo $k > temporaryfile

sed -n 3p cinput1 >> temporaryfile

touch results.output

for i in `seq 1 $k`
do
	bsub -q $QUEUE -J "sub2.$i" -o sub2.$i.out -e sub2.$i.err -f "sub2.$i.out sub2.$i.err <" onesub.sh $HELAC $i
done

alldone=0

until [ $alldone -eq 1 ]
do
	sleep 15

	alldone=1

	for i in `seq 1 $k`
	do
		if [ ! -r sub2.$i.out ]
		then
			alldone=0
		fi
	done
done

mv sub2.* $HELAC/$RUN/2

for i in `seq 1 $k`
do
	cd directory_$i

	test=`grep output -e"average estimate"`

	if [ -n  "$test"  ]
	then
		grep output -e"average estimate" | awk '{print $4}' >> ../results.output
		grep output -e"variance estimate" | awk '{print $3}' >> ../results.output
		grep output -e"lwri:" | awk '{print $5}' >> ../results.output
		grep output -e"w=1" | awk '{print $5}' >> ../results.output
	else
		echo "0" >> ../results.output
		echo "0" >> ../results.output
		echo "0" >> ../results.output
		echo "0" >> ../results.output
	fi

	echo >> ../results.output

	rm -f data*
	unlink linkPDFsets
	unlink cteq6l1.tbl
	gzip kine_*
	gzip even*out
	gzip output
	gzip err_file

	cd ..
	echo "Done run n. $i"
done

$FC $SUMPR/readoutput.f
./a.out >& $HELAC/$RUN/2/output
