      subroutine durham(np,et,xt,p)
      implicit double precision (a-h,o-z)
      parameter(maxn=3628800)

      integer gamma,gamma1

      dimension p(100,4),pboo(4),pin(4)
      dimension qt(100),phi(100),y(100)
      dimension xveg(100)
      dimension ia(10,maxn),ib(10)
      dimension  ich(maxn)
      dimension ich0(maxn)

      save
      data init/0/


      if(init.eq.0)then

       n=np
       cutrap=0.9d0 !2.5d0
       cutpt=60d0
       pi=dacos(-1d0)

       gamma=1
       do i=1,n
        gamma=gamma*i
       enddo       

       gamma1=gamma/n/(n-1)

       print*,'gamma,gamma1',gamma,gamma1
       ia(1:10,1:gamma)=0
       do i=1,gamma
        call permu(ib(1:n),n)
        ia(1:n,i)=ib(1:n)
c       print*,i,'==>',ia(1:n,i)
       enddo

       ndim=2*n-2

       do i=1,gamma
        ich0(i)=i
       enddo

       nch=gamma
       nch=100

       if(nch.gt.gamma)nch=gamma

       if(nch.eq.gamma) then
        do i=1,nch
         ich(i)=i
        enddo
       endif
 
       print*,'durham params:   n,ndim,cutrap,cutpt,gamma,nch'
       print*,'durham params: ',n,ndim,cutrap,cutpt,gamma,nch
       print*,et,xt

c      do i=1,gamma
c       ich0(i)=i
c      enddo
       
       init=1
      endif

c -------------
 

c      do i=1,gamma
c       ich0(i)=i
c      enddo

ccc      if(nch.lt.gamma.and.init.eq.1) then
       if(nch.lt.gamma) then
        do i=1,nch
 1       continue
         j=rnmy(0)*gamma+1 
         ich(i)=ich0(j)
         do k=1,i-1
          if(ich(i).eq.ich(k))goto1
         enddo

c        if(ich0(j).ne.0)then
c         ich(i)=ich0(j)
c         ich0(j)=0
c        else
c         go to 1
c        endif
c
c        ich(i)=23
c        print*,'durham params: ',ia(1:n,ich(i))
c
        enddo
ccc       init=2
ccc       print*,'durham params: ',ich(1:nch)
       endif
 

 100  continue

      qq=dsqrt(et**2-xt**2)

      do k=1,ndim
       xveg(k)=rnmy(0)
      enddo
c     call setveg(1,xveg,ndim)

      do i=2,n
       qt(i)=-cutpt*dlog(xveg(i-1))
      enddo

      
      y(1)=0
      do i=2,n
       f=dexp(4*cutrap*(2*xveg(i-1+(n-1))-1))
       ff=dsqrt(2*f*dcosh(4*cutrap)-1-f**2)
       ch1=(1+f)*dsinh(2*cutrap)/ff
       sh1=(f-1)*dcosh(2*cutrap)/ff
       y(i)=dlog(ch1+sh1)
c      write(99,*)y(i)
       y(i)=y(i)+y(i-1)
      enddo

      phi(1)=0
      do i=2,n
c       phi(i)=2*pi*xveg(i-1+2*(n-1))-phi(i-1)
       phi(i)=2*pi*rnmy(0)      -phi(i-1)
       phi(i)=phi(i)+phi(i-1)
      enddo

C define qt1,phi1
      qx=0
      qy=0
      do i=2,n
       qx=qx+qt(i)*dcos(phi(i))
       qy=qy+qt(i)*dsin(phi(i))
      enddo
      qt(1)=dsqrt(qx*qx+qy*qy)
      c1=-qx/qt(1)
      s1=-qy/qt(1)
      phi(1)=dacos(c1)
      if(s1.lt.0)phi(1)=2*pi-phi(1)


C define x and y1 
      e0=0
      x0=0
      do i=1,n
       e0=e0+qt(i)*dcosh(y(i))
       x0=x0+qt(i)*dsinh(y(i))
      enddo
      q0=dsqrt(e0**2-x0**2)
 
      if(q0/e0.le.0)goto 100

      xres=qq/q0

      ch1=( e0*et-x0*xt)/q0/qq
      sh1=(-x0*et+e0*xt)/q0/qq
      if(ch1+sh1.le.0)goto 100
      y(1)=dlog(ch1+sh1)
 
      do i=2,n
       y(i)=y(i)+y(1)
      enddo

C define momenta
      k=int(rnmy(0)*nch)+1
      p4=0
      p3=0
      p2=0
      p1=0
      do i=1,n
       j=ia(i,ich(k))
       p(j,1)=xres*qt(i)*dcos(phi(i))
       p(j,2)=xres*qt(i)*dsin(phi(i))
       p(j,3)=xres*qt(i)*dsinh(y(i))
       p(j,4)=xres*qt(i)*dcosh(y(i))
       
       p4=p4+p(j,4)
       p3=p3+p(j,3)
       p2=p2+p(j,2)
       p1=p1+p(j,1)
      enddo
c     print*,'1',p4,p3,p2,p1,et,xt
c     print*,'xres',xres


         pboo(4)=p4
         pboo(3)=-p3
         pboo(1:2)=0
         do i=1,n
            j=ia(i,ich(k))
            pin(1:4)=p(j,1:4)
c           print*,j,p(j,1:4)
            call boostl(qq,pboo,pin)
            p(j,1:4)=pin(1:4)
c           print*,j,p(j,1:4)
         enddo


c     p4=0
c     p3=0
c     p2=0
c     p1=0
c     do i=1,n
c      j=ia(i,ich(k))
c      p4=p4+p(j,4)
c      p3=p3+p(j,3)
c      p2=p2+p(j,2)
c      p1=p1+p(j,1)
c     enddo
c     print*,'2',p4,p3,p2,p1,qq

c     print*,'OUT OF'
      return

C define weight factor
      entry durham_wei(w)

      wg=0
      do k1=1,nch

      k2=ich(k1)
      w=1
      pt=0
      do j=2,n
       i1=ia(j  ,k2)
       i2=ia(j-1,k2)
       dy=rapidity(p(i1,1:4))-rapidity(p(i2,1:4))
c      dy=y(i1)-y(i2)
c      pti1=xres*qt(i1)
c      print*,pti1
       pti1=sqrt(p(i1,1)**2+p(i1,2)**2)
c      print*,pti1
c      print*,'---------------'
c      w=w*xres*qt(i1)
       w=w*pti1
     .     /( dtanh(2*cutrap-dy)+dtanh(2*cutrap+dy) )
c      pt=pt+xres*qt(i1)
       pt=pt+pti1
      enddo


      w=w/qq**2
     .   *pt**(n-1)
     .   /2**n
     .   *(2*pi)**(n-1)
     .   *(8*cutrap)**(n-1)
     .   /gamma1

      wg=wg+1d0/w/nch
      enddo

      w=1d0/wg

      return
      end
