C
C      commons to be set by the user
C
C      common/helac_int/n,io(20),ifl(20)
C      
C      common/helac_mom/zq(20,5)
C        n:               number of particles involved
C        zq(1:n,1:5):     momentum 1->  (p0+pz , pz)  
C                                  2->  (p0-pz , pt), pt=sqrt(px^2+py^2)
C                                  3->  (px    , py)
C                                  4->  (px    ,-py)
C                                  5->  (m     , p ), p=sqrt(px^2+py^2+pz^2)
C        ifl(1:n):        flavour
C        io(1:n):         =1 incoming =-1 outgoing
C      common/helac_flags/iflag,iunitary,ihiggs
C        iflag:           0 sum over all helicities, 1 give helicity confg.
C        iunitary:        1 unitary gauge, 0 Feynman gauge
C        ihiggs:          0 no higgs, 1 higgs is included
C      common/helac_masses/parmas(-12:44),parwid(-12:44)
C        parmass:          masses of known particles
C        parwid:           widths of known particles
C       
C       
C    FOR COMPLEX-WIDTH SCHEME 
C    complex mass definition appears in compl_mass.h
C       
C       
C       
C       
**********************************************************
*					                 *
*    The correspondence table for particles              *
*					                 *
*					                 *
*					                 *
*      n,e,u,d,n,m,c,s,...  1,.., 12                     *
* anti-n,e,u,d,n,m,c,s,... -1,..,-12                     *
*      A,Z,W+,W-,...        31,..,34                     *
*      H,f0,f+,f-,...       41,..,44                     *
*					                 *
*					                 *
**********************************************************
C       
C      In the begining ---> call physics
C       
C       
C       
       subroutine helac_init
       include 'declare.h'
      
       include 'common_int.h'
       include 'common_flags.h'
       include 'common_helc.h'
       include 'common_feyn.h'
       include 'common_print.h'
       include 'common_new.h'
       include 'common_unweight.h'
       include 'common_unw.h'
       include 'common_onep.h'
       include 'parameter_NCOL.h'
      
       integer iquark(20)
             
       integer iperm(:,:)
       dimension rmatrix(:,:)
       dimension zamp(:)
       integer jcol(:,:,:)       
 
      allocatable iperm,rmatrix,zamp,jcol
       save rmatrix,zamp,jcol

c      save ncc,avhel,avcol,symet,init,init_col
       save init,init_col
       save iv1,iv2

c      save imc
c      data imc/0/
       
       data ic1/0/
       data iquark/20*0/
       data init/0/,init_col/0/
       data init_unw/0/
    
       logical lwri
       logical onep

c SKELOPTIM[
       logical checkIDon,yes
c...  Set flag checkIDon=.false. to avoid any optimization on the skeleton generation.
c...  Warning: this optimization assumes *Standard Model* vertices. It might not work properly in presence 
c...  of new vertices (e.g. from effective theories)
       checkIDon=.true.
c SKELOPTIM]

**********************************************************
*     ipol(k)=helicity,ipol(k)=2:rigth-handed            *
*                      ipol(k)=1:left-handed             *
*                      ipol(k)=3:long.                   *
**********************************************************
**********************************************************
C      start of initialization phase      
**********************************************************
       call average(avhel,avcol,symet)
       
       write(nunit1,*)'avhel,avcol,symet'
       write(nunit1,*) avhel,avcol,symet
c      call fmprnt(avhel)
c      call fmprnt(avcol)
c      call fmprnt(symet)
      
       
       iv1=31
       iv2=34
      
       call setncc(nq)
       
       ncc=ifactorial(nq)
      
       allocate(iperm(ncc,nq),stat=istat)
       allocate(jcol(ncc,n,0:2),stat=istat)

       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master'
       
       write(nunit1,*)'number of colour configurations',ncc
       call pan(ncc)
              
       if(ncc.gt.1)iv2=35
       
       do icc=1,ncc
                    
       if(nq.ne.0.and.icc.le.ncc)then
        
        if(nq.gt.1)call permu(iquark,nq)
        if(nq.eq.1)iquark(1)=1

        call setcc(iquark)


c       print*,'CHECK',nq,iquark(1:nq)
        call checkgluons(iquark,nq,icheck)
c       print*,'CHECK',icheck
        if(icheck.eq.0)cycle
        
       endif

       write(nunit1,*)'the colour of particles ONE',(icol(i,1),i=1,n)
       write(nunit1,*)'the colour of particles TWO',(icol(i,2),i=1,n)

       call pan_ini
      
       do l=2,n-1
       
       ix1=0
       do while(ix1.eq.0)
       
       call id(n,l,ix1,i0)

       if(ix1.eq.1)goto800

c SKELOPTIM[
       call checkID(i0,yes,icandidate0)
       if(checkIDon.AND.(.NOT.yes))cycle
c SKELOPTIM]

       if(mod(i0,2).eq.0)then
       
       ix2=0
       do while(ix2.eq.0)
       
       call id2(n,l,i0,ix2,i1,i2)

       if(ix2.eq.1)goto801

c SKELOPTIM[
       call checkID(i1,yes,icandidate1)
       if(checkIDon.AND.(.NOT.yes))cycle
       call checkID(i2,yes,icandidate2)
       if(checkIDon.AND.(.NOT.yes))cycle
c SKELOPTIM]
       
       i3=0

c SKELOPTIM[
       do if1=iv1,iv2
       if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.1 .AND.
     .    icandidate2.eq.1))then    !SM candidates: 1=boson , 2=fermion, 3=ghost
          call v3(i0,l,if1,i1,i2,i3)
          call vvs(i0,l,if1,i1,i2,i3)
          call vss(i0,l,if1,i1,i2,i3)
       endif
       if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.2 .AND.
     .    icandidate2.eq.2))then    !SM candidates: 1=boson , 2=fermion, 3=ghost
          call vff(i0,l,if1,i1,i2,i3)
       endif
       enddo
       
       do if1=41,44
       if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.1 .AND.
     .    icandidate2.eq.1))then    !SM candidates: 1=boson , 2=fermion, 3=ghost
          call svv(i0,l,if1,i1,i2,i3)
          call ssv(i0,l,if1,i1,i2,i3)
          call s3(i0,l,if1,i1,i2,i3)
       endif
       if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.2 .AND.
     .    icandidate2.eq.2))then    !SM candidates: 1=boson , 2=fermion, 3=ghost
          call sff(i0,l,if1,i1,i2,i3)
       endif
       enddo

       do if1=1,12
       if((.NOT.checkIDon).OR.(icandidate0.eq.2 .AND. 
     .    icandidate1.eq.1 .AND.
     .    icandidate2.eq.2))then    !SM candidates: 1=boson , 2=fermion, 3=ghost
          call  ffv(i0,l, if1,i1,i2,i3)
          call  ffs(i0,l, if1,i1,i2,i3)
          call affv(i0,l,-if1,i1,i2,i3)
          call affs(i0,l,-if1,i1,i2,i3)
       endif
       enddo
c SKELOPTIM]

 801   enddo
       
c      goto 800
c      print*,'NO V4 INTERACTIONS <<<<<<<<<<<<<<<<<<<<<<<'
       if(l.lt.3)goto800
       ix3=0
       do while(ix3.eq.0)
       
       call id3(n,l,i0,ix3,i1,i2,i3)
c      print*,n,l,i0,ix3,i1,i2,i3
       if(ix3.eq.1)goto802

c SKELOPTIM[
       call checkID(i1,yes,icandidate1)
       if(checkIDon.AND.(.NOT.yes))cycle
       call checkID(i2,yes,icandidate2)
       if(checkIDon.AND.(.NOT.yes))cycle
       call checkID(i3,yes,icandidate3)
       if(checkIDon.AND.(.NOT.yes))cycle
c SKELOPTIM]

c SKELOPTIM[
       do if1=iv1,iv2
       if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.1 .AND.
     .    icandidate2.eq.1 .AND.
     .    icandidate3.eq.1))then !SM candidates: 1=boson , 2=fermion, 3=ghost
          call v4(i0,l,if1,i1,i2,i3)
          call vvss(i0,l,if1,i1,i2,i3)
       endif
       enddo
       
      do if1=41,44
      if((.NOT.checkIDon).OR.(icandidate0.eq.1 .AND. 
     .    icandidate1.eq.1 .AND.
     .    icandidate2.eq.1 .AND.
     .    icandidate3.eq.1))then !SM candidates: 1=boson , 2=fermion, 3=ghost
          call s4(i0,l,if1,i1,i2,i3)
          call ssvv(i0,l,if1,i1,i2,i3)
      endif
      enddo
c SKELOPTIM]
       
 802   enddo
       
       endif
       
 800   enddo
       enddo

       call redo(ic1,ino)
       
       if(nq.ne.0.and.icc.le.ncc.and.ino.eq.0)then
        iperm(ic1,1:nq)=iquark(1:nq)

        jcol(ic1,1:n,1:2)=icol(1:n,1:2)
        jcol(ic1,1,0)=1
        do i=1,n
           if(ifl(i).eq.35.and.icol(i,1).eq.icol(i,2))then
              jcol(ic1,1,0)=0
              goto 100
           endif
        enddo
 100    continue
        
       endif
      enddo                     !icc
       
       write(nunit1,*)'colour',ic1,ncc !-1,ncc
       ncc=ic1!-1
       
       call setlist(ncc)
       
       allocate(
     .  zamp(ncc)
     . ,rmatrix(ncc,ncc)
     . ,stat=istat)
       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master2'
       
       do k1=1,ncc
        do k2=k1,ncc
ccall countzeros(nq,iperm(k1,1:nq)-iperm(k2,1:nq),izeros)
         call eat(nq,iperm(k1,1:nq),iperm(k2,1:nq),izeros)
           rmatrix(k1,k2)=dnou(NCOL)**izeros
c        if(izeros.eq.nq)then
c          rmatrix(k1,k2)=dnou(3)**nq
c        else
c          rmatrix(k1,k2)=dnou(3)**(izeros+1)
c        endif
           if(k2.gt.k1)rmatrix(k2,k1)=rmatrix(k1,k2)
        enddo
       enddo
       
       write(nunit1,*)'ncc,ic1',ncc,ic1
c      do k1=1,ic1
c       print'(100f5.2)',(rmatrix(k1,k2),k2=1,ic1) 
c      enddo
**********************************************************
C      end of initialization phase      
**********************************************************
       print*,'the number of colour configurations',ncc
       print*,'the colour summation flag: imc',imc
       if(ncc.le.24)then
       write(nunit1,*)'the colour matrix'
       do i=1,ncc
       write(nunit1,'(24f8.2)')(rmatrix(i,j),j=1,ncc)
       enddo
       endif
       
       if(repeat.eq.1)then
       write(21,*)ng
       do ii=1,ng
       do jj=1,8
       write(21,*)(is(ii,jj,kk),kk=1,8)
       enddo
       enddo
       write(21,*)avhel,avcol,symet
       write(21,*)rmatrix
        do k=1,ncc
        write(21,*)jcol(k,1:n,0:2)
        enddo
       endif
       
       return
       
      entry helac_master(smel2)

      if(init.eq.0) print*,'NCC=',ncc,' imc=',imc

      if(init.eq.0.and.repeat.eq.2)then
       allocate(
     .  zamp(ncc)
     . ,rmatrix(ncc,ncc)
     . ,jcol(ncc,n,0:2)  
     . ,stat=istat)
       if(istat.ne.0)print*,istat,
     & 'warning: allocation is not working properly in master3'
       read(21,*)avhel,avcol,symet
       read(21,*)rmatrix
        do k=1,ncc
           read(21,*)jcol(k,1:n,0:2)
        enddo
      endif

      smel2=dnou(0)
      
      ihel=0
      istop=0

      do while(istop.eq.0)

      if(iranhel.eq.0)then
      inegl=0
      call sethel(iflag,istop,ihel,inegl)
      inegl=1

      else
      istop=1
      endif
      
      call iniqq

      if(imc.eq.0)then

       do k=1,ncc
          call nextq(k)
          call ampq(k,zamp(k))
          if(onep)then 
           write(100,*)'the ',k,'-th color cnfg out of ',ncc
           if(ncc.gt.1)write(100,*)'the     color',jcol(k,1:n,1)
           if(ncc.gt.1)write(100,*)'the anticolor',jcol(k,1:n,2)
           if(iranhel.eq.0)write(100,*)'the helicity',ipol(1:n)
           write(100,*)'the amplitude',zamp(k)
          endif
       enddo

        w1=dnou(0)
        do k1=1,ncc
         do k2=k1,ncc
          if(k2.eq.k1)
     .    w1=w1+dreal( zamp(k1)*dconjg(zamp(k2) ))*rmatrix(k1,k2) 
          include 'largeNclimit1.h'
c         if(k2.gt.k1)
c    .    w1=w1+2*dreal( zamp(k1)*dconjg(zamp(k2) ))*rmatrix(k1,k2) 
         enddo
        enddo

      else

       k_1=int(rnmy(0)*ncc)+1
c      k_2=int(rnmy(0)*ncc)+1

       call nextq(k_1)
       call ampq(k_1,zamp(k_1))
c      call nextq(k_2)
c      call ampq(k_2,zamp(k_2))

c      w1=dnou(0)
c      w1=dreal( zamp(k_1)*dconjg(zamp(k_2) ))*rmatrix(k_1,k_2)
       w1=dreal( zamp(k_1)*dconjg(zamp(k_1) ))*rmatrix(k_1,k_1)
       w1=w1*ncc

       endif

c unweight over color

c      if(lwri) then
       beta0=0
       k_un=1
       r=rnmy(0)
       wnc=0
       do k=1,ncc
        if(jcol(k,1,0).eq.1)wnc=wnc+dreal( zamp(k)*dconjg(zamp(k) )) 
       enddo
       do k=1,ncc
        alpha=dreal( zamp(k)*dconjg(zamp(k) ))/wnc
        if(jcol(k,1,0).eq.0)alpha=0
        beta1=beta0+alpha
        if(r.gt.beta0.and.r.lt.beta1)then
         k_un=k
         go to 1
        endif
        beta0=beta1
       enddo

 1     icol_un(1:n,1:2)=jcol(k_un,1:n,1:2)
c      endif

       smel2=smel2+w1
      
       if(w1.eq.dnou(0))inegl=2
       if(init.eq.0.and.iranhel.eq.0)call sethel(iflag,istop,ihel,inegl)
       
       
       if(init.eq.0.and.iranhel.eq.0)then
        write(nunit1,*)(ipol(i),i=1,n)
        write(nunit1,*)w1
c       call fmprnt(w1)
       endif

      enddo

*     end of polariazation sum if any
      if(init.eq.0)print*,'HELICITY CFGS',nhc
*     *****************************************************

      smel2=smel2*avhel*avcol*symet

*     *****************************************************
      if(onep)then
       write(100,*)'total amplitude squared = ',smel2
       write(100,*)'----------------------------------------'
      endif
      
      init=init+1 
      if(onep)init=0
c     print*,w1
c     if(init.eq.10)stop

      return
      end
        
      subroutine clean(iflag,zamp,n)
      include 'declare.h'
      
      dimension iflag(n)
      dimension zamp(n)
      
      do k=2,n
      
       do l=1,k-1
       
        if(zamp(l).eq.zamp(k))iflag(k)=l
        if(zamp(l).eq.-zamp(k))iflag(k)=-l
c    .     zamp(l).eq.-zamp(k))then
c        iflag(k)=l
c       endif
        
       enddo
       
      enddo
      
      return
      end
      
      subroutine checkgluons(iq,nq,icheck)
      include 'declare.h'
      include 'common_int.h'
      integer iq(nq)
      save igo,init
      data init/0/,igo/1/
      
      icheck=1
      if(igo.eq.0)return
      if(init.eq.0)then
       igo=0
       init=1
       do i=1,n
        if(ifl(i).ne.35)return
       enddo
       igo=1
      endif

      icheck=0
      i=1
      do ix=1,nq-2
       i=iq(i)
       if(iq(i).eq.1)return
      enddo
      icheck=1

      return
      end
   
      include 'special/master.h'



c SKELOPTIM[
      subroutine checkID(i0,passed,icandidate)

      implicit double precision(a-h,o-z)
      common/helac_int/n0,io(20),ifl(20)
      common/helac_helc/ipol(20),icol(20,2)
      common/helac_nq/nq
      integer ic(0:20,2)
      integer iu(0:20),id(0:20)
      logical passed
      integer y1(20)
      integer q,qtot
      integer f1,f2,f3,f4,f5,f6
      integer f1tot,f2tot,f3tot,f4tot,f5tot,f6tot
      dimension q(-13:44),ix(20),m(20)
      dimension f1(-13:44),f2(-13:44),f3(-13:44)
      dimension f4(-13:44),f5(-13:44),f6(-13:44)
      dimension fg(-13:44),fq(-13:44),flep(-13:44),fewb(-13:44)
      dimension le(-13:44),lm(-13:44),lt(-13:44)
      dimension l1(-13:44),l2(-13:44),l3(-13:44)
      dimension lq(-13:44)
      dimension ighost(-13:44)
      double precision i(-13:44),iini,ifin
      integer an(-13:44)
      data an/13,12,11,10,9,8,7,6,5,4,3,2,1,0,
     .         -1,-2,-3,-4,-5,-6,-7,-8,-9,-10,-11,-12,
     .         -13,14,15,16,17,18,19,20,
     .         21,22,23,24,25,26,27,28,29,30,
     .         31,32,34,33,35,36,37,38,39,40,41,42,44,43/
      logical onlyqcd
      common/onlyqcd/onlyqcd
      save
      data initcb /0/


c...  Initialize quantum numbers
      if(initcb.eq.0)then

c...  Electric charge in units of 1/3
         q(1)=0
         q(2)=-3
         q(3)=2
         q(4)=-1
         q(5)=q(1)
         q(6)=q(2)
         q(7)=q(3)
         q(8)=q(4)
         q(9)=q(1)
         q(10)=q(2)
         q(11)=q(3)
         q(12)=q(4)
         q(31)=0
         q(32)=0
         q(33)=3
         q(34)=-3
         q(35)=0
         q(41)=0
         q(13)=0
c...  SU(2) doublet position ID
         i(1)=1
         i(2)=-1
         i(3)=1
         i(4)=-1
         i(5)=i(1)
         i(6)=i(2)
         i(7)=i(3)
         i(8)=i(4)
         i(9)=i(1)
         i(10)=i(2)
         i(11)=i(3)
         i(12)=i(4)
         i(31)=0
         i(32)=0
         i(33)=2
         i(34)=-2
         i(35)=0
         i(41)=0
         i(13)=0
c QCD charge
         ighost(-13:41)=0
         ighost(13)=1
c L-e
         le(1:44)=0
         le(1:2)=1
c L-muon
         lm(1:44)=0
         lm(5:6)=1
c L-tau
         lt(1:44)=0
         lt(9:10)=1
c L-ud
         l1(1:44)=0
         l1(3:4)=1
c L-cs
         l2(1:44)=0
         l2(7:8)=1
c L-tb
         l3(1:44)=0
         l3(11:12)=1
c L-UD
         lq(1:44)=0
         lq(3:4)=1
         lq(7:8)=1
         lq(11:12)=1
c f-u
         f1(1:44)=0
         f1(3)=1
c f-d
         f2(1:44)=0
         f2(4)=1
c f-c
         f3(1:44)=0
         f3(7)=1
c f-s
         f4(1:44)=0
         f4(8)=1
c f-t
         f5(1:44)=0
         f5(11)=1
c f-b
         f6(1:44)=0
         f6(12)=1
c f-gluon
         fg(1:44)=0
         fg(35)=1
c f-quark
         fq(1:44)=0
         fq(3:4)=1
         fq(7:8)=1
         fq(11:12)=1
c f-lepton
         flep(1:44)=0
         flep(1:2)=1
         flep(5:6)=1
         flep(9:10)=1
c f-EW boson
         fewb(1:44)=0
         fewb(31)=1
         fewb(32)=1
         fewb(33)=1
         fewb(34)=1
         fewb(41)=1

         do k=1,13
            q(-k)=-q(k)
            i(-k)=-i(k)
            le(-k)=-le(k)
            lm(-k)=-lm(k)
            lt(-k)=-lt(k)
            l1(-k)=-l1(k)
            l2(-k)=-l2(k)
            l3(-k)=-l3(k)
            lq(-k)=-lq(k)
            f1(-k)=-f1(k)
            f2(-k)=-f2(k)
            f3(-k)=-f3(k)
            f4(-k)=-f4(k)
            f5(-k)=-f5(k)
            f6(-k)=-f6(k)
            ighost(-k)=-ighost(k)
            fq(-k)=fq(k)
            flep(-k)=flep(k)
         enddo

         m(1:20)= 1
         initcb=1

      endif
c

c...  Identify flavour and color of the external particles entering the bubble i0
      passed=.false.
      iu(0:20)=0
      id(0:20)=0
      ic(0:20,1:2)=0
      call bin(n0,i0,y1)
      k=0
      do ii=1,n0
         if(y1(ii).ne.0)then
            k=k+1
            ix(k)=ifl(n0-ii+1)
            if(n0-ii+1.gt.2)ix(k)=an(ix(k))
            ic(k,1)=icol(n0-ii+1,1)
            ic(k,2)=icol(n0-ii+1,2)
         endif
      enddo
      n=k
      do imio=1,level(n0,i0)
         do j=0,nq
            if(ic(imio,1).eq.j)iu(j)=iu(j)+1
            if(ic(imio,2).eq.j)id(j)=id(j)+1
         enddo
      enddo

c...  Determine the quantum numbers of i0
      qtot=0
      do k=1,n
       qtot=qtot+q(ix(k))*m(k)
      enddo
      itot=0
      do k=1,n
       itot=itot+i(ix(k))*m(k)
      enddo
      letot=0
      do k=1,n
       letot=letot+le(ix(k))*m(k)
      enddo
      lmtot=0
      do k=1,n
       lmtot=lmtot+lm(ix(k))*m(k)
      enddo
      lttot=0
      do k=1,n
       lttot=lttot+lt(ix(k))*m(k)
      enddo
      l1tot=0
      do k=1,n
       l1tot=l1tot+l1(ix(k))*m(k)
      enddo
      l2tot=0
      do k=1,n
       l2tot=l2tot+l2(ix(k))*m(k)
      enddo
      l3tot=0
      do k=1,n
       l3tot=l3tot+l3(ix(k))*m(k)
      enddo
      lqtot=0
      do k=1,n
       lqtot=lqtot+lq(ix(k))*m(k)
      enddo
      f1tot=0
      do k=1,n
       f1tot=f1tot+f1(ix(k))*m(k)
      enddo
      f2tot=0
      do k=1,n
       f2tot=f2tot+f2(ix(k))*m(k)
      enddo
      f3tot=0
      do k=1,n
       f3tot=f3tot+f3(ix(k))*m(k)
      enddo
      f4tot=0
      do k=1,n
       f4tot=f4tot+f4(ix(k))*m(k)
      enddo
      f5tot=0
      do k=1,n
       f5tot=f5tot+f5(ix(k))*m(k)
      enddo
      f6tot=0
      do k=1,n
       f6tot=f6tot+f6(ix(k))*m(k)
      enddo
      ighosttot=0
      do k=1,n
       ighosttot=ighosttot+ighost(ix(k))*m(k)
      enddo
      fgtot=0
      do k=1,n
         fgtot=fgtot+fg(ix(k))
      enddo
      fqtot=0
      do k=1,n
         fqtot=fqtot+fq(ix(k))
      enddo
      fleptot=0
      do k=1,n
         fleptot=fleptot+flep(ix(k))
      enddo
      fewbtot=0
      do k=1,n
         fewbtot=fewbtot+fewb(ix(k))
      enddo

c...  Bubbles containing only gluons and leptons/EW bosons are forbidden in the SM
      if(fgtot.ne.0 .AND. (fleptot.ne.0.OR.fewbtot.ne.0) 
     .     .AND. fqtot.eq.0)return

c...  Check total electric charge
      if(abs(qtot).ne.0 .AND. abs(qtot).ne.1 .AND. 
     .     abs(qtot).ne.2 .AND. abs(qtot).ne.3) return

c...  No ghost particles outside of the loop
      if(ighosttot.gt.1)return

      if(abs(itot).ne.0 .AND. abs(itot).ne.1 .AND. abs(itot).ne.2)return

      if(onlyqcd)then
         if(fewbtot.ne.0)return
         if(fleptot.ne.0)return
      endif

      icandidate=0  !SM cases: 1=boson , 2=fermion, 3=ghost

      if(qtot.eq.0 .AND. itot.eq.0 .AND. ighosttot.eq.0)then
c...  candidate insertion particle is a neutral boson
         icandidate=1  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return
         if(onlyqcd)then
            if(f1tot.ne.0)return
            if(f2tot.ne.0)return
            if(f3tot.ne.0)return
            if(f4tot.ne.0)return
            if(f5tot.ne.0)return
            if(f6tot.ne.0)return
         endif

      elseif(qtot.eq.0 .AND. itot.eq.1)then
c...  candidate insertion particle is a neutrino
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(abs(letot)+abs(lmtot)+abs(lttot).ne.1)return
         if(onlyqcd)return

      elseif(qtot.eq.0 .AND. itot.eq.-1)then
c...  candidate insertion particle is an anti-neutrino
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(abs(letot)+abs(lmtot)+abs(lttot).ne.1)return
         if(onlyqcd)return

      elseif(qtot.eq.3 .AND. itot.eq.2)then
c...  candidate insertion particle is a charged boson: W+ (33)
         icandidate=1  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return
         if(onlyqcd)return

      elseif(qtot.eq.-3 .AND. itot.eq.-2)then
c...  candidate insertion particle is a charged boson: W- (34)
         icandidate=1  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return
         if(onlyqcd)return

      elseif(qtot.eq.3 .AND. itot.eq.1)then
c...  candidate insertion particle is a charged lepton
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(abs(letot)+abs(lmtot)+abs(lttot).ne.1)return
         if(onlyqcd)return

      elseif(qtot.eq.-3 .AND. itot.eq.-1)then
c...  candidate insertion particle is a charged anti-lepton
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(abs(letot)+abs(lmtot)+abs(lttot).ne.1)return
         if(onlyqcd)return

      elseif(qtot.eq.2)then
c...  candidate insertion particle is an up type quark (charge: +2/3)
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(itot.ne.1)return
         if((l1tot+l2tot+l3tot).ne.1)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return

      elseif(qtot.eq.-2)then
c...  candidate insertion particle is an anti-up type quark (charge: -2/3)
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(itot.ne.-1)return
         if((l1tot+l2tot+l3tot).ne.-1)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return

      elseif(qtot.eq.-1)then
c...  candidate insertion particle is a down type quark (charge: -1/3)
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(itot.ne.-1)return
         if((l1tot+l2tot+l3tot).ne.1)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return

      elseif(qtot.eq.1)then
c...  candidate insertion particle is an anti-down type quark (charge: +1/3)
         icandidate=2  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(itot.ne.1)return
         if((l1tot+l2tot+l3tot).ne.-1)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return

      elseif(qtot.eq.0 .AND. itot.eq.0 .AND. abs(ighosttot).eq.1)then
c...  candidate insertion particle is a ghost
         icandidate=3  !SM cases: 1=boson , 2=fermion, 3=ghost
         if(l1tot.ne.0)return
         if(l2tot.ne.0)return
         if(l3tot.ne.0)return
         if(letot.ne.0)return
         if(lmtot.ne.0)return
         if(lttot.ne.0)return
         if(onlyqcd)then
            if(f1tot.ne.0)return
            if(f2tot.ne.0)return
            if(f3tot.ne.0)return
            if(f4tot.ne.0)return
            if(f5tot.ne.0)return
            if(f6tot.ne.0)return
         endif

      endif

      passed=.true.

      return
      end
c SKELOPTIM]
